//===============================CISCKER Observer===============================
//================================Clock Divider=================================
//------------------------------------------------------------------------------
//File Name:	Generate_Arbitrary_Divided_Clk32.v
//Purpose:		Generate an arbitrary divided clock with a 32 bit set input
//Parameters:	None
//------------------------------------------------------------------------------
//=====================Alfredo Gualdron - Jose P. Pinilla=======================
//=================================Semillero ADT================================
//================================UPB Bucaramanga===============================
//Website:	http://semilleroadt.upbbga.edu.co/xiscker
//E-mail:	semilleroadt@gmail.com
//------------------------------------------------------------------------------

module Generate_Arbitrary_Divided_Clk32(input inclk, output outclk, 
outclk_Not, input [25:0] div_clk_count, input reset);

reg [25:0] OUT_next;
reg OUT_reg =0;

always @ (posedge inclk) 
	if (reset)
		begin
			OUT_next <= 0;
		end
	else
	begin
		if (OUT_next != (div_clk_count -1))
			begin
			OUT_next <= OUT_next +1;
			OUT_reg <= OUT_reg;
			end
		else 
			begin OUT_next <= 0;
					OUT_reg <= ~OUT_reg;
				end
	end

assign outclk = OUT_reg;
assign outclk_Not = ~OUT_reg;

endmodule

